DROP TABLE IF EXISTS `cu_users`;
DROP TABLE IF EXISTS `cu_user_groups`;
DROP TABLE IF EXISTS `cu_menu_items_extra_data`;
DROP TABLE IF EXISTS `cu_menu_items`;
DROP TABLE IF EXISTS `cu_menus`;
DROP TABLE IF EXISTS `cu_menu_item_type`;
DROP TABLE IF EXISTS `cu_tables`;
DROP TABLE IF EXISTS `cu_permissions`;
DROP TABLE IF EXISTS `cu_articles`;
DROP TABLE IF EXISTS `cu_categories`;

CREATE TABLE `cu_articles` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(50) NOT NULL,
  `summary` text,
  `article` text,
  `date_registered` date DEFAULT NULL,
  `categories_id` int(11) NOT NULL,
  `enabled` int(1) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_cu_categories` (`categories_id`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;

CREATE TABLE `cu_categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;

INSERT INTO `cu_categories` VALUES (1,'Uncategorised');
CREATE TABLE `cu_menu_item_type` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(45) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COMMENT='Content menu types.\nExample:  [1, none], [2, autogenerated],';

INSERT INTO `cu_menu_item_type` VALUES (1,'None');
INSERT INTO `cu_menu_item_type` VALUES (2,'Auto administrate');
INSERT INTO `cu_menu_item_type` VALUES (3,'Personalized component');
INSERT INTO `cu_menu_item_type` VALUES (4,'URL');
CREATE TABLE `cu_menu_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(45) NOT NULL,
  `menu_item_type_id` int(11) NOT NULL,
  `menu_item_params` varchar(250) DEFAULT NULL,
  `parent_id` int(11) DEFAULT NULL,
  `menus_id` int(11) NOT NULL,
  `order` int(11) DEFAULT NULL,
  `enabled` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `fk_cu_menu_item_type` (`menu_item_type_id`),
  KEY `fk_cu_menu` (`menus_id`)
) ENGINE=InnoDB AUTO_INCREMENT=46 DEFAULT CHARSET=utf8 COMMENT='Content menu items.\nParent_id: Relation about the positions ';

INSERT INTO `cu_menu_items` VALUES (1,'Users',3,'{\"component_name\":\"user_panel\"}',0,1,10,1);
INSERT INTO `cu_menu_items` VALUES (2,'User groups',2,'{\"table_name\":\"cu_user_groups\", \"defined_task\":\"\"}',1,1,4,1);
INSERT INTO `cu_menu_items` VALUES (6,'Help',1,'',0,1,12,1);
INSERT INTO `cu_menu_items` VALUES (19,'User accounts',2,'{\"table_name\":\"cu_users\", \"defined_task\":\"\"}',1,1,3,1);
INSERT INTO `cu_menu_items` VALUES (20,'Help center',4,'{\"url\":\"http://www.tufikgroup.com/cuppa/documentation/\",\"target\":\"iframe\"}',6,1,1,1);
INSERT INTO `cu_menu_items` VALUES (32,'Developer page',4,'{\"url\":\"http://www.tgoldengroup.com\",\"target\":\"_blank\"}',6,1,2,1);
INSERT INTO `cu_menu_items` VALUES (41,'Profile',2,'{\"table_name\":\"cu_users\", \"defined_task\":\"&task=edit&id=session\"}',0,1,1,1);
INSERT INTO `cu_menu_items` VALUES (42,'Content',3,'{\"component_name\":\"content_panel\"}',0,1,11,1);
INSERT INTO `cu_menu_items` VALUES (43,'Categories',2,'{\"table_name\":\"cu_categories\", \"defined_task\":\"\"}',42,1,1,1);
INSERT INTO `cu_menu_items` VALUES (44,'Articles',2,'{\"table_name\":\"cu_articles\", \"defined_task\":\"\"}',42,1,2,1);
CREATE TABLE `cu_menu_items_extra_data` (
  `menu_items_id` int(11) NOT NULL,
  `string_name` varchar(100) DEFAULT NULL,
  `permissions_params` varchar(2000) NOT NULL,
  PRIMARY KEY (`menu_items_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Content relation between table and permission.\nExample: [1, ';

INSERT INTO `cu_menu_items_extra_data` VALUES (1,'user_panel','{\"Super admin\":{\"consult\":\"1\",\"insert\":\"1\",\"edit\":\"1\",\"delete\":\"1\"},\"Admin\":{\"consult\":\"0\",\"insert\":\"0\",\"edit\":\"0\",\"delete\":\"0\"},\"User\":{\"consult\":\"0\",\"insert\":\"0\",\"edit\":\"0\",\"delete\":\"0\"}}');
INSERT INTO `cu_menu_items_extra_data` VALUES (2,'cu_user_groups','{\"Super admin\":{\"consult\":\"1\",\"insert\":\"1\",\"edit\":\"1\",\"delete\":\"1\"},\"Admin\":{\"consult\":\"0\",\"insert\":\"0\",\"edit\":\"0\",\"delete\":\"0\"},\"User\":{\"consult\":\"0\",\"insert\":\"0\",\"edit\":\"0\",\"delete\":\"0\"}}');
INSERT INTO `cu_menu_items_extra_data` VALUES (6,'','{\"Super admin\":{\"consult\":\"1\",\"insert\":\"1\",\"edit\":\"1\",\"delete\":\"1\"},\"Admin\":{\"consult\":\"1\",\"insert\":\"0\",\"edit\":\"0\",\"delete\":\"0\"},\"User\":{\"consult\":\"0\",\"insert\":\"0\",\"edit\":\"0\",\"delete\":\"0\"}}');
INSERT INTO `cu_menu_items_extra_data` VALUES (19,'cu_users','{\"Super admin\":{\"consult\":\"1\",\"insert\":\"1\",\"edit\":\"1\",\"delete\":\"1\"},\"Admin\":{\"consult\":\"0\",\"insert\":\"0\",\"edit\":\"1\",\"delete\":\"0\"},\"User\":{\"consult\":\"0\",\"insert\":\"0\",\"edit\":\"0\",\"delete\":\"0\"}}');
INSERT INTO `cu_menu_items_extra_data` VALUES (20,'','{\"Super admin\":{\"consult\":\"1\",\"insert\":\"1\",\"edit\":\"1\",\"delete\":\"1\"},\"Admin\":{\"consult\":\"1\",\"insert\":\"0\",\"edit\":\"0\",\"delete\":\"0\"},\"User\":{\"consult\":\"0\",\"insert\":\"0\",\"edit\":\"0\",\"delete\":\"0\"}}');
INSERT INTO `cu_menu_items_extra_data` VALUES (32,'','{\"Super admin\":{\"consult\":\"1\",\"insert\":\"0\",\"edit\":\"0\",\"delete\":\"0\"},\"Admin\":{\"consult\":\"1\",\"insert\":\"0\",\"edit\":\"0\",\"delete\":\"0\"},\"User\":{\"consult\":\"0\",\"insert\":\"0\",\"edit\":\"0\",\"delete\":\"0\"}}');
INSERT INTO `cu_menu_items_extra_data` VALUES (41,'cu_users','{\"Super admin\":{\"consult\":\"1\",\"insert\":\"1\",\"edit\":\"1\",\"delete\":\"1\"},\"Admin\":{\"consult\":\"1\",\"insert\":\"0\",\"edit\":\"1\",\"delete\":\"0\"},\"User\":{\"consult\":\"0\",\"insert\":\"0\",\"edit\":\"0\",\"delete\":\"0\"}}');
INSERT INTO `cu_menu_items_extra_data` VALUES (42,'content_panel','{\"Super admin\":{\"consult\":\"1\",\"insert\":\"1\",\"edit\":\"1\",\"delete\":\"1\"},\"Admin\":{\"consult\":\"1\",\"insert\":\"1\",\"edit\":\"1\",\"delete\":\"1\"},\"User\":{\"consult\":\"0\",\"insert\":\"0\",\"edit\":\"0\",\"delete\":\"0\"}}');
INSERT INTO `cu_menu_items_extra_data` VALUES (43,'cu_categories','{\"Super admin\":{\"consult\":\"1\",\"insert\":\"1\",\"edit\":\"1\",\"delete\":\"1\"},\"Admin\":{\"consult\":\"1\",\"insert\":\"1\",\"edit\":\"1\",\"delete\":\"1\"},\"User\":{\"consult\":\"0\",\"insert\":\"0\",\"edit\":\"0\",\"delete\":\"0\"}}');
INSERT INTO `cu_menu_items_extra_data` VALUES (44,'cu_articles','{\"Super admin\":{\"consult\":\"1\",\"insert\":\"1\",\"edit\":\"1\",\"delete\":\"1\"},\"Admin\":{\"consult\":\"1\",\"insert\":\"1\",\"edit\":\"1\",\"delete\":\"1\"},\"User\":{\"consult\":\"0\",\"insert\":\"0\",\"edit\":\"0\",\"delete\":\"0\"}}');
CREATE TABLE `cu_menus` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(45) NOT NULL,
  `description` varchar(250) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;

INSERT INTO `cu_menus` VALUES (1,'admin_menu','Administrator menu required');
CREATE TABLE `cu_permissions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(45) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COMMENT='Content permissions.\nExample: [1, consult] , [2, insert]';

INSERT INTO `cu_permissions` VALUES (1,'consult');
INSERT INTO `cu_permissions` VALUES (2,'insert');
INSERT INTO `cu_permissions` VALUES (3,'edit');
INSERT INTO `cu_permissions` VALUES (4,'delete');
CREATE TABLE `cu_tables` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `table_name` varchar(45) NOT NULL,
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `table_name_UNIQUE` (`table_name`)
) ENGINE=InnoDB AUTO_INCREMENT=37 DEFAULT CHARSET=utf8 COMMENT='Content the table info.\nExample: [1, Products, {field name: ';

INSERT INTO `cu_tables` VALUES (20,'cu_permissions','{\"id\":{\"type\":\"Id\",\"label\":\"Id\",\"showList\":1,\"required\":1},\"title\":{\"type\":\"Text\",\"label\":\"Title\",\"showList\":1,\"required\":1,\"config\":{\"type\":\"text\"}},\"primary_key\":\"id\"}');
INSERT INTO `cu_tables` VALUES (21,'cu_menus','{\"id\":{\"type\":\"Id\",\"label\":\"Id\",\"showList\":1,\"required\":1},\"name\":{\"type\":\"Text\",\"label\":\"Name\",\"showList\":1,\"required\":1,\"config\":{\"type\":\"text\"}},\"description\":{\"type\":\"Text\",\"label\":\"Description\",\"showList\":1,\"required\":0,\"config\":{\"type\":\"text\"}},\"primary_key\":\"id\"}');
INSERT INTO `cu_tables` VALUES (22,'cu_menu_item_type','{\"id\":{\"type\":\"Id\",\"label\":\"Id\",\"showList\":1,\"required\":1},\"name\":{\"type\":\"Text\",\"label\":\"Name\",\"showList\":1,\"required\":1,\"config\":{\"type\":\"text\"}},\"primary_key\":\"id\"}');
INSERT INTO `cu_tables` VALUES (25,'cu_user_groups','{\"id\":{\"type\":\"Id\",\"label\":\"Id\",\"showList\":1,\"required\":1},\"name\":{\"type\":\"Text\",\"label\":\"Name\",\"showList\":1,\"required\":1,\"config\":{\"type\":\"text\"}},\"site_login\":{\"type\":\"Select\",\"label\":\"Site login\",\"showList\":1,\"required\":1,\"config\":[[\"1\",\"true\"],[\"0\",\"false\"]]},\"admin_login\":{\"type\":\"Select\",\"label\":\"Admin login\",\"showList\":1,\"required\":1,\"config\":[[\"1\",\"true\"],[\"0\",\"false\"]]},\"super_admin_login\":{\"type\":\"Select\",\"label\":\"Super admin login\",\"showList\":1,\"required\":1,\"config\":[[\"1\",\"true\"],[\"0\",\"false\"]]},\"enabled\":{\"type\":\"Select\",\"label\":\"Enabled\",\"showList\":1,\"required\":1,\"config\":[[\"1\",\"true\"],[\"0\",\"false\"]]},\"primary_key\":\"id\"}');
INSERT INTO `cu_tables` VALUES (26,'cu_users','{\"id\":{\"type\":\"Id\",\"label\":\"Id\",\"showList\":1,\"required\":1},\"name\":{\"type\":\"Text\",\"label\":\"Name\",\"showList\":1,\"required\":1,\"config\":{\"type\":\"text\"}},\"email\":{\"type\":\"Text\",\"label\":\"Email\",\"showList\":0,\"required\":1,\"config\":{\"type\":\"email\"}},\"username\":{\"type\":\"Text\",\"label\":\"Username\",\"showList\":1,\"required\":1,\"config\":{\"type\":\"text\"}},\"password\":{\"type\":\"Text\",\"label\":\"Password\",\"showList\":0,\"required\":1,\"config\":{\"type\":\"password\",\"encode\":\"md5\"}},\"enabled\":{\"type\":\"Select\",\"label\":\"Enabled\",\"showList\":1,\"required\":1,\"config\":[[\"1\",\"true\"],[\"0\",\"false\"]]},\"user_group_id\":{\"type\":\"Select\",\"label\":\"User group id\",\"showList\":1,\"required\":1,\"config\":{\"table_name\":\"cu_user_groups\",\"data_column\":\"id\",\"label_column\":\"name\"}},\"primary_key\":\"id\"}');
INSERT INTO `cu_tables` VALUES (35,'cu_categories','{\"id\":{\"type\":\"Id\",\"label\":\"Id\",\"showList\":1,\"required\":1},\"name\":{\"type\":\"Text\",\"label\":\"Name\",\"showList\":1,\"required\":1,\"config\":{\"type\":\"text\"}},\"primary_key\":\"id\"}');
INSERT INTO `cu_tables` VALUES (36,'cu_articles','{\"id\":{\"type\":\"Id\",\"label\":\"Id\",\"showList\":1,\"required\":1},\"title\":{\"type\":\"Text\",\"label\":\"Title\",\"showList\":1,\"required\":1,\"config\":{\"type\":\"text\"}},\"summary\":{\"type\":\"TextArea\",\"label\":\"Summary\",\"showList\":0,\"required\":0,\"config\":{\"editor\":\"none\",\"width\":\"750\",\"height\":\"70\"}},\"article\":{\"type\":\"TextArea\",\"label\":\"Article\",\"showList\":0,\"required\":0,\"config\":{\"editor\":\"tinymce\",\"width\":\"750\",\"height\":\"250\"}},\"date_registered\":{\"type\":\"Date\",\"label\":\"Date registered\",\"showList\":1,\"required\":1,\"config\":{\"type\":\"datePicker\",\"config\":\"auto_today_selected\"}},\"categories_id\":{\"type\":\"Select\",\"label\":\"Categories id\",\"showList\":1,\"required\":1,\"config\":{\"table_name\":\"cu_categories\",\"data_column\":\"id\",\"label_column\":\"name\"}},\"enabled\":{\"type\":\"Select\",\"label\":\"Enabled\",\"showList\":1,\"required\":1,\"config\":[[\"1\",\"true\"],[\"0\",\"false\"]]},\"primary_key\":\"id\"}');
CREATE TABLE `cu_user_groups` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(45) NOT NULL,
  `site_login` int(11) NOT NULL DEFAULT '1',
  `admin_login` int(11) NOT NULL DEFAULT '0',
  `super_admin_login` int(11) NOT NULL DEFAULT '0',
  `enabled` int(11) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

INSERT INTO `cu_user_groups` VALUES (1,'Super admin',1,1,1,1);
INSERT INTO `cu_user_groups` VALUES (2,'Admin',1,1,0,1);
INSERT INTO `cu_user_groups` VALUES (3,'User',1,0,0,1);
CREATE TABLE `cu_users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(45) NOT NULL,
  `email` varchar(45) NOT NULL,
  `username` varchar(45) NOT NULL,
  `password` varchar(250) NOT NULL,
  `enabled` int(11) NOT NULL DEFAULT '1',
  `user_group_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_cu_user_group` (`user_group_id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;

ALTER TABLE `cu_articles`
ADD CONSTRAINT `fk_cu_categories` FOREIGN KEY (`categories_id`) REFERENCES `cu_categories` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `cu_menu_items`
ADD CONSTRAINT `fk_cu_menu` FOREIGN KEY (`menus_id`) REFERENCES `cu_menus` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION,
ADD CONSTRAINT `fk_cu_menu_item_type` FOREIGN KEY (`menu_item_type_id`) REFERENCES `cu_menu_item_type` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION;

ALTER TABLE `cu_menu_items_extra_data`
ADD CONSTRAINT `fk_cu_menu_items` FOREIGN KEY (`menu_items_id`) REFERENCES `cu_menu_items` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `cu_users`
ADD CONSTRAINT `fk_cu_user_group` FOREIGN KEY (`user_group_id`) REFERENCES `cu_user_groups` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;